<template>
  <div
    class="row"
  >
    <div
      class="col q-pa-sm"
    >
      <div class="q-pa-md row items-start q-gutter-md">
        <!-- UPLOAD QUEUE -->
        <q-card
          :hidden="queuedUploads.length===0"
          flat
          bordered
          class="slide-card"
        >
          <div class="q-pa-sm slide-card">
            <upload-queue
              ref="uploadQueue"
              :upload-manager="uploadManager"
            />
          </div>
        </q-card>
        <!-- QUEUED UPLOADS -->
        <upload-card
          v-for="upload in queuedUploads"
          :key="upload.file.id"
          :upload="upload"
          @start-upload="startUpload(upload)"
          @delete-upload="deleteUpload(upload)"
        />
        <!-- UPLOAD PROGRESS -->
        <q-card
          :hidden="runningUploads.length===0"
          flat
          bordered
          class="slide-card"
        >
          <div class="q-pa-sm slide-card">
            <upload-progress
              ref="uploadProgress"
              :upload-manager="uploadManager"
              @cancel-all="cancelAll"
            />
          </div>
        </q-card>
        <!-- RUNNING UPLOADS -->
        <upload-card
          v-for="upload in runningUploads"
          :key="upload.file.id"
          :upload="upload"
          @delete-upload="deleteUpload(upload)"
        />
        <!-- CARD INDICATING SLIDE LOADING -->
        <q-card
          v-if="updating"
          flat
          bordered
          class="slide-card"
        >
          <q-item class="loading-card">
            <q-item-section style="">
              <q-spinner-cube
                color="gray"
                size="2em"
                style="margin-left: auto; margin-right: auto;"
              />
            </q-item-section>
          </q-item>
        </q-card>
        <!-- SLIDES -->
        <slide-card
          v-for="slide in searchFilteredSlides"
          :key="slide.id"
          :slide="slide"
          :tissue-options="tissueOptions"
          :stain-options="stainOptions"
          :creator-id="creatorId"
          @delete-slide="deleteSlide(slide)"
        />
      </div>
    </div>
    <!-- DROPZONE DIALOG -->
    <q-dialog
      v-model="showSlideUploader"
    >
      <q-card
        flat
        bordered
      >
        <div class="q-pa-sm">
          <dropzone
            ref="dropzone"
            drop-text="Drop slides here"
            :supported-formats="supportedFormats"
            :supported-multi-file-formats="supportedMultiFileFormats"
            :supported-anonymization-formats="supportedAnonymizationFormats"
            :already-added-file-ids="alreadyAddedFileIds"
            :file-group="caseId"
            @dropped-files="handleDroppedFiles($event)"
          />
        </div>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { v5 as uuidv5 } from 'uuid'
import mds from '../mixins/mds_api'
import mps from '../mixins/mps_api'
import UploadProgress from './UploadProgress.vue'
import SlideCard from './SlideCard.vue'
import UploadCard from './UploadCard.vue'
import Dropzone from './Dropzone.vue'
import { supportedFormats, supportedMultiFileFormats, supportedAnonymizationFormats } from '../mixins/file_formats'
import { getLabel, getUpdatedSlidePromise, deleteSlide } from '../mixins/slides'
import UploadQueue from './UploadQueue.vue'

export default {
  name: 'Slides',
  components: {
    dropzone: Dropzone,
    uploadProgress: UploadProgress,
    slideCard: SlideCard,
    uploadCard: UploadCard,
    uploadQueue: UploadQueue
  },
  props: {
    uploadManager: {
      type: Object,
      default: function () {
        return null
      }
    },
    caseId: {
      type: String,
      default: ''
    },
    localCaseId: {
      type: String,
      default: ''
    },
    creatorId: {
      type: String,
      default: 'default_user'
    },
    searchSlide: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      supportedFormats: supportedFormats,
      supportedMultiFileFormats: supportedMultiFileFormats,
      supportedAnonymizationFormats: supportedAnonymizationFormats,
      tissueOptions: [],
      stainOptions: [],
      slides: [], // Slides from MDS
      loadingSlides: false, // Flag for loading slides from the MDS
      queuedUploads: [],
      runningUploads: [],
      showSlideUploader: false
    }
  },
  computed: {
    updating () {
      return this.loadingSlides
    },
    searchFilteredSlides () {
      if (this.searchSlide) {
        return this.slides.filter(x => x.searchMatch === true)
      } else {
        return this.slides
      }
    },
    alreadyAddedFileIds () {
      const alreadyAddedFileIds = []
      for (const slide of this.slides) {
        if (slide.storage) {
          alreadyAddedFileIds.push(slide.storage.main_storage_address.storage_address_id)
          for (const storageAddress of slide.storage.secondary_storage_addresses) { alreadyAddedFileIds.push(storageAddress.storage_address_id) }
        }
      }
      let currentlyUploadingFileIds = []
      if (this.uploadManager) {
        currentlyUploadingFileIds = this.uploadManager.getAllFileIds()
      }
      return alreadyAddedFileIds.concat(currentlyUploadingFileIds)
    }
  },
  watch: {
    uploadManager: {
      handler () {
        this.queuedUploads = this.uploadManager.getUploadsWithStates(['checking', 'queued'])
        this.runningUploads = this.uploadManager.getUploadsWithStates(['uploading', 'paused', 'waiting', 'failed'])
      },
      deep: true
    },
    caseId: function () {
      this.slides = []
      this.loadingSlides = false
      this.loadSlides()
    },
    searchSlide: function () {
      for (const slide of this.slides) {
        slide.searchMatch = false
        if (slide.id.includes(this.searchSlide)) {
          slide.searchMatch = true
        }
        const filename = localStorage.getItem(slide.localId) || ''
        if (filename.includes(this.searchSlide)) {
          slide.searchMatch = true
        }
        const possibleLocalId = uuidv5(this.localCaseId + this.searchSlide, slide.case_id)
        if (possibleLocalId === slide.localId) {
          slide.searchMatch = true
          localStorage.setItem(slide.localId, this.searchSlide)
        }
      }
    }
  },
  async created () {
    this.getLabel = getLabel
    const tags = await mps.getTags()
    this.tissueOptions = []
    for (const tissue of Object.entries(tags.tissues)) {
      this.tissueOptions.push({ label: tissue[1].tag_translations[0].text, value: tissue[1].name })
    }
    this.sortLabels(this.tissueOptions)
    this.stainOptions = []
    for (const stain of Object.entries(tags.stains)) {
      this.stainOptions.push({ label: stain[1].tag_translations[0].text, value: stain[1].name })
    }
    this.sortLabels(this.stainOptions)
  },
  methods: {
    async handleDroppedFiles (droppedFiles) {
      this.showSlideUploader = false
      const newUploads = []
      for (const file of droppedFiles) {
        newUploads.push(this.uploadManager.add(file, this.caseId))
      }
      await this.uploadManager.waitForAnonymization()
      for (const newUpload of newUploads) {
        await newUpload.anonymize()
      }
    },
    async addSlide (slideId) {
      this.loadingSlides = true
      const slide = await mds.getSlide(slideId)
      const updatedSlide = await getUpdatedSlidePromise(slide)
      if (updatedSlide != null) {
        this.slides.push(updatedSlide)
        this.resetSlideSearch()
        this.sortSlides()
      }
      this.loadingSlides = false
    },
    startUpload (upload) {
      this.uploadManager.startUpload(upload)
    },
    deleteUpload (upload) {
      this.uploadManager.remove(upload)
    },
    checkFileAlreadyPartOfUploadedSlide (fileId) {
      for (const slide of this.slides) {
        if (slide.storage) {
          if (fileId === slide.storage.main_storage_address.storage_address_id) {
            return true
          }
          for (const address of slide.storage.secondary_storage_addresses) {
            if (fileId === address.storage_address_id) {
              return true
            }
          }
        }
      }
      return false
    },
    cancelAll () {
      this.uploadManager.cancel()
    },
    // SLIDE LOADING
    async loadSlides (parallelSlideUpdates = 10) {
      this.loadingSlides = true
      this.slides = []
      const caseId = this.caseId
      const slides = (await mds.getAllSlides(this.caseId)).filter(x => x.deleted !== true)
      let parallelPromises = []
      for (const [i, slide] of slides.entries()) {
        if (this.caseId === caseId) {
          const updatedSlidePromise = getUpdatedSlidePromise(slide)
          parallelPromises.push(updatedSlidePromise)
          if (parallelPromises.length === parallelSlideUpdates || i === slides.length - 1) {
            let updatedSlides = await Promise.all(parallelPromises)
            if (this.caseId === caseId) {
              updatedSlides = updatedSlides.filter(x => x !== null)
              this.slides.push(...updatedSlides)
              this.resetSlideSearch()
              this.sortSlides()
            }
            parallelPromises = []
          }
        }
      }
      if (this.caseId === caseId) {
        this.loadingSlides = false
      }
    },
    sortSlides () {
      this.slides.sort(function (a, b) {
        if (a.created_at < b.created_at) {
          return 1
        }
        if (a.created_at > b.created_at) {
          return -1
        }
        return 0
      })
    },
    sortLabels (labels) {
      labels.sort(function (a, b) {
        var nameA = a.label.toUpperCase()
        var nameB = b.label.toUpperCase()
        if (nameA < nameB) {
          return -1
        }
        if (nameA > nameB) {
          return 1
        }
        return 0
      })
    },
    resetSlideSearch () {
      for (const slide of this.slides) {
        slide.searchMatch = false
      }
    },
    // SLIDE DELETION
    async deleteAllSlides (showLoading = false) {
      for (const slide of this.slides) {
        await this.deleteSlide(slide, showLoading, false)
      }
    },
    async deleteSlide (slide, showLoading = true, notify = true) {
      if (showLoading) {
        this.$q.loading.show({
          delay: 500 // ms
        })
      }
      await deleteSlide(slide)
      this.slides = this.slides.filter(x => x.id !== slide.id)
      if (showLoading) {
        this.$q.loading.hide()
      }
      if (notify) {
        this.notifySlideDeletion(slide)
      }
    },
    notifySlideDeletion (slide) {
      this.$q.notify({
        color: 'green-4',
        textColor: 'white',
        icon: 'cloud_done',
        message: `Slide ${getLabel(slide)} deleted`,
        timeout: 500
      })
    },
    // SLIDE MAPPINGS
    saveMappings () {
      const mappings = {}
      for (const slide of this.slides) {
        mappings[slide.localId] = localStorage.getItem(slide.localId)
      }
      var dataStr = 'data:text/json;charset=utf-8,' + encodeURIComponent(JSON.stringify(mappings, null, 2))
      var downloadElement = document.createElement('a')
      downloadElement.setAttribute('href', dataStr)
      downloadElement.setAttribute('download', this.localCaseId + '_mappings.json')
      document.body.appendChild(downloadElement)
      downloadElement.click()
      downloadElement.remove()
    }
  }
}
</script>

<style lang="sass" scoped>
.slide-card
  width: 250px
  height: 400px
.loading-card
  width: 100%
  height: 100%
</style>
